function index = codeword_search(y, Y);
% 
% search the index of codeword for a code
% y is a 1*D vector
% Y is a N*D matrix

% y = rand(1,10);
% Y = rand(200,10);

[m n] = size(Y);

Y0 = repmat(y,m,1);

temp = (Y0 - Y).^2;

err = sum(temp,2);

[val ind] = sort(err);

index = ind(1);